<template id="modal">
    <div 
        class="modal fade" 
        id="crearModal" 
        tabindex="-1" 
        role="dialog" 
        aria-labelledby="exampleModalLabel" 
        aria-hidden="true"
        @blur="resetForm()"
    >
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">
                        Subir Archivo(s)
                    </h5>
                    <button 
                        type="button" 
                        class="close" 
                        data-dismiss="modal" 
                        aria-label="Close"
                    >
                        <span aria-hidden="true" @click="resetForm()">
                            &times;
                        </span>
                    </button>
                </div>
                <div class="modal-body">
                    <b-card 
                       no-nody 
                       class="overflow-hidden" 
                    >
                        <b-row no-gutters>
                            <b-col md="12">
                                <b-card-body>
                                    <div class="mb-3 row">
                                        <label 
                                            for="archivo" 
                                            class="col-sm-3 col-form-label"
                                        >
                                            Archivo
                                        </label>
                                        <div class="col-sm-9">
                                            
                                            <input 
                                                class="form-control" 
                                                type="file" 
                                                id="js-input-file"
                                                name="archivo"
                                                src="ruta + '/img/iconos/Subir_archivo_del_modal_y_del_boton.png'"
                                                required
                                                multiple 
                                                @change="onChangeInputFile"
                                            />
                                            <div style="font-size: 12; color: tomato;">
                                                {{ errorsBack.files }}
                                            </div>
                                        </div>
                                    </div>
                                    <div class="mb-3 row">
                                        <label class="col-sm-3 col-form-label">
                                            Carpeta
                                        </label>
                                        <div class="col-sm-9">
                                            <select
                                                class="form-control" 
                                                @change="onChangeCarpeta"  
                                                required
                                                id="js-select-carpeta"
                                            >
                                                <option 
                                                    value=""
                                                    selected="true" 
                                                    disabled="disabled"
                                                >
                                                    Selecciona
                                                </option>
                                                <option  
                                                    v-for="(carpeta, index) in carpetas" 
                                                    :key="index" 
                                                    :value="JSON.stringify(carpeta)"
                                                >
                                                    {{ carpeta.nombre }}
                                                </option>
                                            </select>
                                            <div style="font-size: 12; color: tomato;">
                                                {{ errorsBack.carpeta }}
                                            </div>
                                        </div>
                                    </div>
                                </b-card-body>
                            </b-col>
                        </b-row>
                    </b-card>
                </div>
                <div class="modal-footer">
                    <button 
                        type="button" 
                        class="btn btn-primary"
                        data-dismiss="modal"
                        @click="resetForm()"
                    >
                        Cancelar
                    </button>
                    <button 
                        type="button" 
                        class="btn btn-primary"
                        @click="guardarArchivo()"
                    >
                        Subir
                    </button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { isEmpty } from './../../utils/isEmpty';

export default {

    props: {
        carpetas: {
            type: Array,
            default: []
        }
    },

    data: () => {
        return {
            files: [],
            selectedIdCarpeta: 0,
            selectedNombreCarpeta: "",
            errorsBack: {
                carpeta: "",
                files: ""
            }
        }
    },

    methods: {
        onChangeCarpeta(event) {

            const carpetaSelected = JSON.parse(event.target.value);

            this.selectedIdCarpeta = carpetaSelected.id_carpeta;
            this.selectedNombreCarpeta = carpetaSelected.nombre;
        },

        resetErrors() {

            Object
                .entries(this.errorsBack)
                .forEach(([key, value]) => this.errorsBack[key] = "");
        },

        async guardarArchivo() {

            if (this.archivoFormIsInvalid()) return;

            const archivoForm = {
                id_usuario: localStorage.getItem('idUsuario'),
                id_carpeta: this.selectedIdCarpeta,
                carpeta: this.selectedNombreCarpeta,
                numberFiles: this.files.length
            }

            const dataPost = new FormData();
            dataPost.append('params', JSON.stringify(archivoForm));

            for (let i = 0; i < this.files.length; i++) {
                dataPost.append(`file-${i}`, this.files[i]);
            }

            try {

                const response = await axios.post(`/api/archivos`, dataPost);

                this.$utils.showSuccess(response.data['message']);
                this.$emit('archivo-registrado');

            } catch (error) {
                
                const errorRequest = JSON.parse(error.request.response);

                Object
                    .entries(errorRequest['errors'])
                    .forEach(([key, value]) => this.errorsBack[key] = value[0]);
            }

        },

        onChangeInputFile(event) {
            
            this.files = [];
            const filesSelected = event.target.files;

            for(var i = 0; i< filesSelected.length; i++) {
                this.files.push(filesSelected[i]);
            }
        },

        resetForm() {

            const files = document.getElementById("js-input-file");
            files.value = "";
            this.files = [];

            const selectCarpeta = document.getElementById("js-select-carpeta");
            selectCarpeta.value = "";
            this.selectedIdCarpeta = 0;
            this.selectedNombreCarpeta = "";

            this.resetErrors();
        },

        archivoFormIsInvalid() {

            var errorCount = 0;
            this.resetErrors();

            if (isEmpty(this.files.length)) {
                this.errorsBack.files = "Archivo(s) es requerido";
                errorCount++; 
            }

            if (isEmpty(this.selectedNombreCarpeta)) {
                this.errorsBack.carpeta = "Carpeta es requerido";
                errorCount++; 
            }

            return errorCount > 0;
        }
    }
}
</script>